SystemOrganization addCategory: #MiniToDo!

Object subclass: #SistemaTareas
	instanceVariableNames: 'tareas list selectedIndex '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiniToDo'!

!SistemaTareas commentStamp: 'gsa 2/7/2004 10:20' prior: 0!
Very simple task administration system.

Developed mainly as a learning-project. A lot of features must be added.

Sorry by the "spanglish" mix :)

Need a PluggableListMorph.

To start the app, evaluate:

SistemaTareas new initialize openAViewOnMe

Programmer: Germn S. Arduino
Date: Octubre 2003
Last Modificaton: February 2004!

!SistemaTareas methodsFor: 'accessing' stamp: 'gsa 7/21/2003 19:23'!
list
	^list! !

!SistemaTareas methodsFor: 'accessing' stamp: 'gsa 10/12/2003 21:56'!
listIndex: anInteger 
	selectedIndex := anInteger.
		self changed: #listIndex! !

!SistemaTareas methodsFor: 'initializing' stamp: 'gsa 7/21/2003 20:54'!
initialize
	self agregarTareas.
	list := (self tareas
				collect: [:each | each descripcion])
				asSortedCollection: [:a :b | a = b].
	selectedIndex := 1! !

!SistemaTareas methodsFor: 'updating' stamp: 'gsa 10/13/2003 17:53'!
modificarTarea
	| aTask aTaskDescription aTaskNewDescription |
	aTaskDescription := list at: selectedIndex.
	aTask := self tareas
				detect: [:each | each descripcion = aTaskDescription].
	aTaskNewDescription := FillInTheBlank request: 'Modifique la descripcin de la Tarea' initialAnswer: aTaskDescription.
	"Lo siguiente es para evitar descripciones en blanco"
	"Falta ver si se puede detectar de mejor forma si se presion el  
	Cancel del FillInTheBlank"
	aTaskNewDescription size = 0
		ifFalse: [aTask descripcion: aTaskNewDescription.
			self refreshList]! !

!SistemaTareas methodsFor: 'removing' stamp: 'gsa 10/13/2003 12:17'!
eliminarTarea
	| aTask aTaskDescription |
	aTaskDescription := list at: selectedIndex.
	aTask := (self tareas
				detect: [:each | each descripcion = aTaskDescription]).
	tareas remove: aTask.
	self refreshList! !

!SistemaTareas methodsFor: 'user interface' stamp: 'gsa 10/13/2003 10:21'!
openAViewOnMe
	| window aListMorph |
	aListMorph := PluggableListMorph
				on: self
				list: #list
				selected: #listIndex
				changeSelected: #listIndex:
				menu: #listMenu:.
	"I am the model that has a list to display"
	"This is how the morph gets the list from me"
	"This is how the morph knows which item to highlight"
	"This is how the morph informs me of a user selection"
	"This is how the morph requests a menu for the list"
	aListMorph color: Color gray.
	window := SystemWindow labelled: 'Tareas Pendientes Small-Land'.
	window color: Color lightGray;
		
		addMorph: aListMorph
		frame: (0 @ 0 corner: 1 @ 1).
	^ window openInWorldExtent: 420 @ 220! !

!SistemaTareas methodsFor: 'updating' stamp: 'gsa 10/13/2003 10:14'!
refreshList
	list := (self tareas
				collect: [:each | each descripcion])
				asSortedCollection: [:a :b | a = b].
	selectedIndex := 1.
	self changed: #list! !

!SistemaTareas methodsFor: 'accessing' stamp: 'gsa 7/21/2003 19:19'!
listIndex
	^ selectedIndex! !

!SistemaTareas methodsFor: 'initializing' stamp: 'gsa 10/13/2003 12:17'!
initializeTareas
	"Private - Initializes the receiver's tareas."
	tareas := Bag new! !

!SistemaTareas methodsFor: 'help' stamp: 'gsa 2/7/2004 10:18'!
mostrarAyuda
	| sh |
	'Muestra un workspace con ayuda'.
	sh := StringHolder new textContents: 'Esta es la lista de tareas pendientes.

Las pendientes-urgentes se muestran en rojo.
Las pendientes normales en amarillo.
Las tareas terminadas se muestran en verde.

Por supuesto, lo de los colores y estados de las tareas, an falta implementar.

Programado por: Germn S. Arduino
Fecha: Octubre 2003

Visite: http://www.arsol.net - http://www.arsol.biz
' withSqueakLineEndings;
				 openLabel: 'Ayuda de Tareas'.
	sh topView extent: 350 @ (Display height - 220).
	"sh topView position: Display width - 220 @ 20."
	"sh topView beSticky."
	"sh topView collapse."
	sh topView position: Display width - 380 @ 20! !

!SistemaTareas methodsFor: 'accessing' stamp: 'gsa 7/21/2003 19:07'!
tareas
	"Returns the receiver's tareas."
	tareas isNil
		ifTrue: [self initializeTareas].
	^ tareas! !

!SistemaTareas methodsFor: 'adding' stamp: 'gsa 10/13/2003 15:15'!
agregarTarea
	| x newDescription |
	x := Tarea new.
	newDescription := FillInTheBlank request: 'Ingrese la nueva Tarea'.
	"Lo siguientes es para evitar descripciones en blanco"
	"Falta ver si se puede detectar de mejor forma si se presion el 
	Cancel del FillInTheBlank"
	newDescription size = 0
		ifFalse: [x descripcion: newDescription.
			self tareas add: x.
			self refreshList]! !

!SistemaTareas methodsFor: 'user interface' stamp: 'gsa 10/13/2003 18:06'!
listMenu: aMenu 
	"-------------------------------------------------------------------------------------"
	"Si el menu se despliega sin ninguna tarea seleccionada slo  
	ofrece la posibilidad de Agregar Tarea"
	"-------------------------------------------------------------------------------------"
	"Aqui tambin identifico targetTask, la tarea seleccionada,  
	sobre la cual operamos"
	"-------------------------------------------------------------------------------------"
	| differentMenu targetTask tinyMenu |
	self.
	targetTask := list
				at: selectedIndex
				ifAbsent: [tinyMenu := DumberMenuMorph new.
					tinyMenu
						add: 'Agregar Tarea'
						target: self
						selector: #agregarTarea;
						add: 'Ayuda'
						target: self
						selector: #mostrarAyuda.
					^ tinyMenu].
	differentMenu := DumberMenuMorph new.
	"selector indica el mtodo que se ejecuta en target"
	differentMenu
		add: 'Agregar Tarea'
		target: self
		selector: #agregarTarea;
		
		add: 'Eliminar Tarea'
		target: self
		selector: #eliminarTarea;
		
		add: 'Modificar Tarea'
		target: self
		selector: #modificarTarea;
		
		add: 'Ayuda'
		target: self
		selector: #mostrarAyuda;
		
		add: 'explore'
		target: targetTask
		selector: #explore.
	^ differentMenu! !

!SistemaTareas methodsFor: 'adding' stamp: 'gsa 10/13/2003 10:19'!
agregarTareas
	| x |
	x := Tarea new.
	x descripcion: 'Actualizar ToDos SmallLand'.
	self tareas add: x.
	x := Tarea new.
	x descripcion: 'Actualizar Tutorial Presentaciones'.
	self tareas add: x.
	x := Tarea new.
	x descripcion: 'Ver OSProcess'.
	self tareas add: x.
	x := Tarea new.
	x descripcion: 'Ver tema Live Linux con Squeak como WM'.
	self tareas add: x! !

Object subclass: #Tarea
	instanceVariableNames: 'descripcion '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiniToDo'!

!Tarea commentStamp: 'gsa 2/7/2004 10:14' prior: 0!
Task object: The task that administer the system.!

!Tarea methodsFor: 'accessing' stamp: 'gsa 7/21/2003 20:52'!
descripcion
	^descripcion! !

!Tarea methodsFor: 'accessing' stamp: 'gsa 10/12/2003 21:24'!
descripcion: anObject 
	descripcion := anObject.
	self changed: #descripcion! !
